// --------------------------------------------------------------------------------------
//
// GrandNap.CS                                                     Ulrich Mller 01.09.04
//                                                                 PCS1700       C# Final
// Grand Napoleon Patience nach der VB.NET Version Sep. 02 (VB6 Sep. 99)
// Das eigentliche Spiel liegt in der Klasse GrandNapPat
// Basis sind PotiPatCS.DLL und QCard32.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using PotiPatCS;

namespace GrandNapCS
{
	public class frmMain : System.Windows.Forms.Form
	{
		// --- Globale Daten -------------------------
		private GrandNapPat gn;
		private int ArbeitsMode = 0;
		private int SpielNr;
		private int Wiederholung = 0;
		private string IniName = new DirectoryInfo(".\\").FullName + "GrandNapCS.DAT";
		private GlobaleDaten gp;

		// --- Form Controls -------------------------
		private System.Windows.Forms.Button cmdWeiter;
		private System.Windows.Forms.Button cmdNext;
		private System.Windows.Forms.Label lblRunde;
		private System.Windows.Forms.Label lblRestKarten;
		private System.Windows.Forms.Label lblRestTalon;
		private System.Windows.Forms.MainMenu mnuMain;
		private System.Windows.Forms.MenuItem mnuSpiel;
		private System.Windows.Forms.MenuItem mnuOptionen;
		private System.Windows.Forms.MenuItem mnuHilfe;
		private System.Windows.Forms.MenuItem mnuNeu;
		private System.Windows.Forms.MenuItem mnuWahl;
		private System.Windows.Forms.MenuItem mnuNext;
		private System.Windows.Forms.MenuItem mnuWieder;
		private System.Windows.Forms.MenuItem mnuDummy1;
		private System.Windows.Forms.MenuItem mnuEnde;
		private System.Windows.Forms.MenuItem mnuStatistik;
		private System.Windows.Forms.MenuItem mnuScore;
		private System.Windows.Forms.MenuItem mnuIndex;
		private System.Windows.Forms.MenuItem mnuAbout;
		private System.Windows.Forms.Panel pnlDisplay;
		private System.Windows.Forms.Label lblTitel;
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.pnlDisplay = new System.Windows.Forms.Panel();
			this.lblRestTalon = new System.Windows.Forms.Label();
			this.lblRestKarten = new System.Windows.Forms.Label();
			this.lblRunde = new System.Windows.Forms.Label();
			this.cmdNext = new System.Windows.Forms.Button();
			this.cmdWeiter = new System.Windows.Forms.Button();
			this.lblTitel = new System.Windows.Forms.Label();
			this.mnuMain = new System.Windows.Forms.MainMenu();
			this.mnuSpiel = new System.Windows.Forms.MenuItem();
			this.mnuNeu = new System.Windows.Forms.MenuItem();
			this.mnuWahl = new System.Windows.Forms.MenuItem();
			this.mnuNext = new System.Windows.Forms.MenuItem();
			this.mnuWieder = new System.Windows.Forms.MenuItem();
			this.mnuDummy1 = new System.Windows.Forms.MenuItem();
			this.mnuEnde = new System.Windows.Forms.MenuItem();
			this.mnuOptionen = new System.Windows.Forms.MenuItem();
			this.mnuStatistik = new System.Windows.Forms.MenuItem();
			this.mnuScore = new System.Windows.Forms.MenuItem();
			this.mnuHilfe = new System.Windows.Forms.MenuItem();
			this.mnuIndex = new System.Windows.Forms.MenuItem();
			this.mnuAbout = new System.Windows.Forms.MenuItem();
			this.pnlDisplay.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlDisplay
			// 
			this.pnlDisplay.Controls.AddRange(new System.Windows.Forms.Control[] {
																																						 this.lblRestTalon,
																																						 this.lblRestKarten,
																																						 this.lblRunde,
																																						 this.cmdNext,
																																						 this.cmdWeiter});
			this.pnlDisplay.Location = new System.Drawing.Point(224, 40);
			this.pnlDisplay.Name = "pnlDisplay";
			this.pnlDisplay.Size = new System.Drawing.Size(160, 112);
			this.pnlDisplay.TabIndex = 0;
			this.pnlDisplay.Visible = false;
			// 
			// lblRestTalon
			// 
			this.lblRestTalon.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblRestTalon.Location = new System.Drawing.Point(56, 64);
			this.lblRestTalon.Name = "lblRestTalon";
			this.lblRestTalon.Size = new System.Drawing.Size(48, 40);
			this.lblRestTalon.TabIndex = 4;
			this.lblRestTalon.Text = "0";
			this.lblRestTalon.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblRestKarten
			// 
			this.lblRestKarten.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblRestKarten.Location = new System.Drawing.Point(96, 40);
			this.lblRestKarten.Name = "lblRestKarten";
			this.lblRestKarten.Size = new System.Drawing.Size(40, 24);
			this.lblRestKarten.TabIndex = 3;
			this.lblRestKarten.Text = "0";
			this.lblRestKarten.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblRunde
			// 
			this.lblRunde.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblRunde.Location = new System.Drawing.Point(16, 40);
			this.lblRunde.Name = "lblRunde";
			this.lblRunde.Size = new System.Drawing.Size(32, 24);
			this.lblRunde.TabIndex = 2;
			this.lblRunde.Text = "0";
			this.lblRunde.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmdNext
			// 
			this.cmdNext.BackColor = System.Drawing.SystemColors.Control;
			this.cmdNext.Location = new System.Drawing.Point(24, 72);
			this.cmdNext.Name = "cmdNext";
			this.cmdNext.Size = new System.Drawing.Size(120, 24);
			this.cmdNext.TabIndex = 1;
			this.cmdNext.Text = "&Nchste Runde";
			this.cmdNext.Visible = false;
			this.cmdNext.Click += new System.EventHandler(this.cmdNext_Click);
			// 
			// cmdWeiter
			// 
			this.cmdWeiter.BackColor = System.Drawing.SystemColors.Control;
			this.cmdWeiter.Location = new System.Drawing.Point(16, 8);
			this.cmdWeiter.Name = "cmdWeiter";
			this.cmdWeiter.Size = new System.Drawing.Size(120, 24);
			this.cmdWeiter.TabIndex = 0;
			this.cmdWeiter.Text = "&Weiter";
			this.cmdWeiter.Click += new System.EventHandler(this.cmdWeiter_Click);
			// 
			// lblTitel
			// 
			this.lblTitel.Font = new System.Drawing.Font("Comic Sans MS", 24F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTitel.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.lblTitel.Location = new System.Drawing.Point(240, 224);
			this.lblTitel.Name = "lblTitel";
			this.lblTitel.Size = new System.Drawing.Size(400, 216);
			this.lblTitel.TabIndex = 1;
			this.lblTitel.Text = "This is the famous Grand Napoleon Patience";
			this.lblTitel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// mnuMain
			// 
			this.mnuMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																						this.mnuSpiel,
																																						this.mnuOptionen,
																																						this.mnuHilfe});
			// 
			// mnuSpiel
			// 
			this.mnuSpiel.Index = 0;
			this.mnuSpiel.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																						 this.mnuNeu,
																																						 this.mnuWahl,
																																						 this.mnuNext,
																																						 this.mnuWieder,
																																						 this.mnuDummy1,
																																						 this.mnuEnde});
			this.mnuSpiel.Text = "&Spiel";
			// 
			// mnuNeu
			// 
			this.mnuNeu.Index = 0;
			this.mnuNeu.Text = "&Neues Spiel";
			this.mnuNeu.Click += new System.EventHandler(this.mnuNeu_Click);
			// 
			// mnuWahl
			// 
			this.mnuWahl.Index = 1;
			this.mnuWahl.Text = "Spiel &Auswahl";
			this.mnuWahl.Click += new System.EventHandler(this.mnuWahl_Click);
			// 
			// mnuNext
			// 
			this.mnuNext.Index = 2;
			this.mnuNext.Text = "N&chstes Spiel";
			this.mnuNext.Click += new System.EventHandler(this.mnuNext_Click);
			// 
			// mnuWieder
			// 
			this.mnuWieder.Enabled = false;
			this.mnuWieder.Index = 3;
			this.mnuWieder.Text = "Spiel &Wiederholen";
			this.mnuWieder.Click += new System.EventHandler(this.mnuWieder_Click);
			// 
			// mnuDummy1
			// 
			this.mnuDummy1.Index = 4;
			this.mnuDummy1.Text = "-";
			// 
			// mnuEnde
			// 
			this.mnuEnde.Index = 5;
			this.mnuEnde.Text = "B&eenden";
			this.mnuEnde.Click += new System.EventHandler(this.mnuEnde_Click);
			// 
			// mnuOptionen
			// 
			this.mnuOptionen.Index = 1;
			this.mnuOptionen.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																								this.mnuStatistik,
																																								this.mnuScore});
			this.mnuOptionen.Text = "&Optionen";
			// 
			// mnuStatistik
			// 
			this.mnuStatistik.Index = 0;
			this.mnuStatistik.Text = "&Statistik";
			this.mnuStatistik.Click += new System.EventHandler(this.mnuStatistik_Click);
			// 
			// mnuScore
			// 
			this.mnuScore.Index = 1;
			this.mnuScore.Text = "Score &Board";
			// 
			// mnuHilfe
			// 
			this.mnuHilfe.Index = 2;
			this.mnuHilfe.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																						 this.mnuIndex,
																																						 this.mnuAbout});
			this.mnuHilfe.Text = "&Hilfe";
			// 
			// mnuIndex
			// 
			this.mnuIndex.Index = 0;
			this.mnuIndex.Text = "&Index";
			// 
			// mnuAbout
			// 
			this.mnuAbout.Index = 1;
			this.mnuAbout.Text = "&About";
			this.mnuAbout.Click += new System.EventHandler(this.mnuAbout_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.BackColor = System.Drawing.Color.Green;
			this.ClientSize = new System.Drawing.Size(664, 525);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.lblTitel,
																																	this.pnlDisplay});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mnuMain;
			this.Name = "frmMain";
			this.Text = "Grand Napoleon CS";
			this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.frmMain_MouseDown);
			this.Load += new System.EventHandler(this.frmMain_Load);
			this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.frmMain_MouseUp);
			this.Closed += new System.EventHandler(this.frmMain_Closed);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.frmMain_Paint);
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.frmMain_MouseMove);
			this.pnlDisplay.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void frmMain_Load(object sender, System.EventArgs e) {
		// --- GrandNapPat instanzieren, QCard32.DLL initialisieren ---
			try {
				gn = new GrandNapPat(this, pnlDisplay, lblRunde, lblRestKarten, lblRestTalon);
			}
			catch (NapException et) {
				MessageBox.Show(et.Message, "Grand Napoleon CS");
				this.Close();
			}
			gn.GameWon += new GrandNapPat.WonDelegate(GameWon);

			// --- Persistente Daten ----------------------------------------
			if(File.Exists(IniName)) {
				System.Runtime.Serialization.Formatters.Binary.BinaryFormatter ser =
					new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
				FileStream bin = new FileStream(IniName, FileMode.Open);
				gp = (GlobaleDaten)ser.Deserialize(bin);
				bin.Close();
			}
			else {
				gp = new GlobaleDaten();
				gp.LastVisit = DateTime.Now;
			}
			this.Width = 854;
			this.Height = 740;
			this.Left   = gp.FormLeft;
			this.Top    = gp.FormTop;
			gn.Back     = gp.BackNr;
			SpielNr     = gp.KartenSeed;
		}

		// --- Form-Ereignisse -------------------------------------------------------

		private void frmMain_Closed(object sender, System.EventArgs e) {
		// --- Persistente Daten --------------------------------------
		System.Runtime.Serialization.Formatters.Binary.BinaryFormatter ser =
			new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
			FileStream bin = new FileStream(IniName, FileMode.Create);
			gp.FormLeft = this.Left;
			gp.FormTop  = this.Top;
			gp.KartenSeed = SpielNr;
			gp.LastVisit  = DateTime.Now;
			gp.BackNr     = gn.Back;
			ser.Serialize(bin, gp);
			bin.Close();
		}

		private void frmMain_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
			if(ArbeitsMode > 0) gn.Refresh();
		}

		private void mnuEnde_Click(object sender, System.EventArgs e) {
			this.Close();
		}

		private void mnuAbout_Click(object sender, System.EventArgs e) {
			NapAbout About = new NapAbout();
			About.ShowDialog();
		}

		private void mnuStatistik_Click(object sender, System.EventArgs e) {
			NapStatistik Statistik = new NapStatistik(gp);
			Statistik.ShowDialog();
		}

		// --- Maus-Ereignisse ------------------------------------------------------

		private void frmMain_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			gn.StartZiehen(e.X, e.Y);
		}

		private void frmMain_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e) {
			gn.WeiterZiehen(e.X, e.Y);
		}

		private void frmMain_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e) {
			gn.EndeZiehen(e.X, e.Y);
		}

		// ---- Spiel-Steuerung -------------------------------------------------------

		private void cmdNext_Click(object sender, System.EventArgs e) {
			if(!gn.NachsteRunde()) ArbeitsMode = 2;
			cmdNext.Visible = false;
			cmdWeiter.Visible = true;
		}

		private void cmdWeiter_Click(object sender, System.EventArgs e) {
			if(gn.NachsteZeile()) return;
			cmdWeiter.Visible = false;
			if(ArbeitsMode == 1) cmdNext.Visible = true;
		}

		// ---- GameWon Ereignis -----------------------------------------------------------
		
		private void GameWon(object sender, int Runde, int Zuege) {
			int Punkte; string RText;

			gp.GamesWon++;
			gp.LastWon = DateTime.Now;
			cmdWeiter.Visible = false;
			cmdNext.Visible   = false;
			Punkte            = 500 - Zuege;
			RText = "in " + Runde.ToString() + " Runden";
			if(Runde == 2) Punkte += 500;
			if(Runde == 1) {
				Punkte += 1000;
				RText = "in EINER RUNDE";
			}
			if(gp.BestPoints < Punkte) gp.BestPoints = Punkte;
			gp.LastScore = Punkte;
			lblTitel.Text = "Gewonnen\n" + RText + "\nmit " + Zuege.ToString() +
				" Zgen\nund " + Punkte.ToString() + " Punkten";
			lblTitel.Visible = true;
		}

		// -------------------- Menue Routinen -------------------------------------------

		private void mnuNeu_Click(object sender, System.EventArgs e) {
			Wiederholung = 0;
			SpielNr = new Random().Next(1, 16000);
			Start("");
		}

		private void mnuNext_Click(object sender, System.EventArgs e) {
			Wiederholung = 0;
			SpielNr++;
			Start("");
		}

		private void mnuWahl_Click(object sender, System.EventArgs e) {
			NapWahl Wahl = new NapWahl();
			Wahl.txtSpielNr.Text = SpielNr.ToString();
			if(Wahl.ShowDialog() == DialogResult.Cancel) return;
			Wiederholung = 0;
			try {
				SpielNr = Convert.ToInt32(Wahl.txtSpielNr.Text);
				Start("");
			}
			catch(Exception) {return;}
		}

		private void mnuWieder_Click(object sender, System.EventArgs e) {
			Wiederholung++;
			Start(String.Format(" --- {0}. Wiederholung ---", Wiederholung));
		}

		// --- Diverses ----------------------------------------------------------

		private void Start(string ZusatzText) {
			lblTitel.Visible = false;
			this.Text = "Grand Napoleon CS : " + SpielNr.ToString() + ZusatzText;
			gp.GamesTotal++;
			gn.SpielStarten(SpielNr);
			ArbeitsMode        = 1;
			pnlDisplay.Visible = true;
			cmdNext.Visible    = false;
			cmdWeiter.Visible  = true;
			mnuWieder.Enabled  = true;
		}
	}
}
