// -------------------------------------------------------------------------------------
//
// NapStatistik.CS                                                Ulrich Mller 04.09.04
//                                                                PCS1700       C# Final
// GrandNapCS : Ausgabe Statistik-Daten
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GrandNapCS {
	public class NapStatistik : System.Windows.Forms.Form	{

		private GlobaleDaten gp;

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button cmdOK;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label lblGamesTotal;
		private System.Windows.Forms.Label lblBestPoints;
		private System.Windows.Forms.Label lblLastVisit;
		private System.Windows.Forms.Label lblLastWon;
		private System.Windows.Forms.Label lblGamesWon;

		public NapStatistik(GlobaleDaten gp)	{
			InitializeComponent();
			this.gp = gp;
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(NapStatistik));
			this.label1 = new System.Windows.Forms.Label();
			this.cmdOK = new System.Windows.Forms.Button();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.lblGamesTotal = new System.Windows.Forms.Label();
			this.lblBestPoints = new System.Windows.Forms.Label();
			this.lblLastVisit = new System.Windows.Forms.Label();
			this.lblLastWon = new System.Windows.Forms.Label();
			this.lblGamesWon = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(24, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(344, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "Grand Napoleon CS - Statistik";
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdOK.Location = new System.Drawing.Point(304, 272);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.Size = new System.Drawing.Size(72, 24);
			this.cmdOK.TabIndex = 1;
			this.cmdOK.Text = "&OK";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(272, 80);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(92, 92);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox1.TabIndex = 2;
			this.pictureBox1.TabStop = false;
			// 
			// lblGamesTotal
			// 
			this.lblGamesTotal.Location = new System.Drawing.Point(32, 96);
			this.lblGamesTotal.Name = "lblGamesTotal";
			this.lblGamesTotal.Size = new System.Drawing.Size(216, 16);
			this.lblGamesTotal.TabIndex = 3;
			this.lblGamesTotal.Text = "Gesamtspiele";
			// 
			// lblBestPoints
			// 
			this.lblBestPoints.Location = new System.Drawing.Point(32, 160);
			this.lblBestPoints.Name = "lblBestPoints";
			this.lblBestPoints.Size = new System.Drawing.Size(216, 16);
			this.lblBestPoints.TabIndex = 4;
			this.lblBestPoints.Text = "HighScore";
			// 
			// lblLastVisit
			// 
			this.lblLastVisit.Location = new System.Drawing.Point(32, 208);
			this.lblLastVisit.Name = "lblLastVisit";
			this.lblLastVisit.Size = new System.Drawing.Size(336, 16);
			this.lblLastVisit.TabIndex = 5;
			this.lblLastVisit.Text = "Datum letzter Besuch";
			// 
			// lblLastWon
			// 
			this.lblLastWon.Location = new System.Drawing.Point(32, 240);
			this.lblLastWon.Name = "lblLastWon";
			this.lblLastWon.Size = new System.Drawing.Size(336, 16);
			this.lblLastWon.TabIndex = 6;
			this.lblLastWon.Text = "Datum letzter Gewinn";
			// 
			// lblGamesWon
			// 
			this.lblGamesWon.Location = new System.Drawing.Point(32, 128);
			this.lblGamesWon.Name = "lblGamesWon";
			this.lblGamesWon.Size = new System.Drawing.Size(216, 16);
			this.lblGamesWon.TabIndex = 7;
			this.lblGamesWon.Text = "davon gewonnen";
			// 
			// NapStatistik
			// 
			this.AcceptButton = this.cmdOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.CancelButton = this.cmdOK;
			this.ClientSize = new System.Drawing.Size(400, 309);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.lblGamesWon,
																																	this.lblLastWon,
																																	this.lblLastVisit,
																																	this.lblBestPoints,
																																	this.lblGamesTotal,
																																	this.pictureBox1,
																																	this.cmdOK,
																																	this.label1});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "NapStatistik";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Grand Napoleon CS";
			this.TopMost = true;
			this.Load += new System.EventHandler(this.NapStatistik_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void NapStatistik_Load(object sender, System.EventArgs e) {
			lblGamesTotal.Text = "Anzahl Spiele gesamt : " + gp.GamesTotal.ToString();
			lblGamesWon.Text   = "davon gewonnen : " + gp.GamesWon.ToString();
			lblBestPoints.Text = "HighScore : " + gp.BestPoints.ToString();
			lblLastVisit.Text  = String.Format("Letzter Besuch {0:d}", gp.LastVisit);
			lblLastWon.Text    = String.Format("Zuletzt gewonnen {0:d} mit {1} Punkten",
				gp.LastWon, gp.LastScore);
		}

		private void cmdOK_Click(object sender, System.EventArgs e) {
			this.Close();
		}
	}
}
