// -------------------------------------------------------------------------------------
//
// PotiMain.CS                                                    Ulrich Mller 27.06.04
//                                                                PCS1700       C# Final
// Testrahmen fr die Klassenbibliothek PotiPatCS
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace PotiPatTestCS
{
	public class frmMain : System.Windows.Forms.Form
	{
		TestPatience tp;
		private int SpielNr; bool ArbeitsMode;
		private System.Windows.Forms.Button cmdAction;

		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			InitializeComponent();

		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdAction = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cmdAction
			// 
			this.cmdAction.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cmdAction.BackColor = System.Drawing.SystemColors.Control;
			this.cmdAction.Location = new System.Drawing.Point(488, 440);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(88, 24);
			this.cmdAction.TabIndex = 0;
			this.cmdAction.Text = "StartSpiel";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.Green;
			this.ClientSize = new System.Drawing.Size(602, 485);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdAction});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "frmMain";
			this.Text = "PotiPatCS : TestPatience";
			this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.frmMain_MouseDown);
			this.Load += new System.EventHandler(this.frmMain_Load);
			this.DoubleClick += new System.EventHandler(this.frmMain_DoubleClick);
			this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.frmMain_MouseUp);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.frmMain_Paint);
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.frmMain_MouseMove);
			this.ResumeLayout(false);

		}
		#endregion


		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void frmMain_Load(object sender, System.EventArgs e) {
			try {
				tp = new TestPatience(this);
			}
			catch(TestPatException et) {
				MessageBox.Show(et.Message, "TestPatience");
				this.Close();
			}
		}

		private void frmMain_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
			if(ArbeitsMode) tp.Refresh();
		}

		private void frmMain_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			tp.StartZiehen(e.X, e.Y);
		}

		private void frmMain_MouseMove(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			tp.WeiterZiehen(e.X, e.Y);
		}

		private void frmMain_MouseUp(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			tp.EndeZiehen(e.X, e.Y);
		}

		private void frmMain_DoubleClick(object sender, System.EventArgs e) {
			tp.KarteAblegen();
		}

		private void cmdAction_Click(object sender, System.EventArgs e) {
			SpielNr = 1;
			tp.SpielStarten(SpielNr);
			ArbeitsMode = true;
			cmdAction.Visible = false;		
		}
	}
}
